/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.pb162.store;

import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.SortedSet;
import java.util.TreeSet;

/**
 *
 * @author bar
 */
public class StoreImpl implements Store{

    Map<Integer,List<Item>> items = new HashMap<Integer, List<Item>>();
        
    public void addItems(Item ... items) {
        
        if(items == null) throw new IllegalArgumentException("items");
        
        for(int i = 0 ; i < items.length ; i++){
            if(items[i] == null){ throw new IllegalArgumentException("Item "+i);
            }
        }
        
        for(Item item:items){
            List<Item> itemsList;
            if(this.items.containsKey(item.getID())){
                itemsList = this.items.get(item.getID());
            }else{
                itemsList = new LinkedList<Item>();
            }
            itemsList.add(item);
            this.items.put(item.getID(), itemsList);
        }
        
    }

    public SortedSet<Item> getItemsFromProducer() {
        return sortBy(SortType.Producer);
    }

    public SortedSet<Item> getItemsByDescription() {
        return sortBy(SortType.Description);
    }
    
    private SortedSet<Item> sortBy(SortType what){
        Comparator<Item> comparator;
        if(what == what.Producer ){
            comparator = new ProducerComparator();
        }else{
            comparator = new DescriptionComparator();
        }
        SortedSet<Item> sortedItems = new TreeSet<Item>(comparator);
        for(Integer id:items.keySet()){
            sortedItems.addAll(items.get(id));
        }
        return Collections.unmodifiableSortedSet(sortedItems);
    }
    
    public String toString(){
        StringBuilder desc = new StringBuilder("Sklad:\n");
        for(Integer id:items.keySet()){
            desc.append(id+":");
            desc.append(items.get(id));
            desc.append("\n");
        }
        return desc.toString();
    }
}
